#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

#define coder       JBeppu
#define VERSION     0.80
#define NotSilent   0

#define xx_ACCESS   0
#define Rx_ACCESS   1
#define xW_ACCESS   2
#define RW_ACCESS   3

#define EOLN_UNIX   0
#define EOLN_DOS    1
#define ALLOC_STEP  32          // Please let this be a power of two.
#define MAX         128

// begin.structures ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,

typedef unsigned long   ulong;

struct LineDef {
    char*       oData;          // "o" for original
    ulong       oLen;
    char*       data;           // free()'d by destructor ONLY
    ulong       len;
    ulong       trueLen;        // (trueLen > oLen) ? data : oData;
};

class TextFile {

    private:

    ulong       accessMODE;     // null, read-only, write-only, r/w {0123}
    ulong       lineQTY;        // number of lines
    ulong       currentLINE;    // current line
    ulong       fileSIZE;       // useless information I don't need
    char        *origBUF;       // original buffer
    LineDef     *lineDefLUT;    // line info
    char        name[MAX];      // file name
    char        eolnStr[4];     // (eolnTYPE) ? "\15\12\0\0" : "\12\0\0\0"

    public:

    ulong       eolnTYPE;       // 0:UN*X; non-zero:DOS


    private:

    int loadOrigBUF
        (
        char *filename
        );

    void initLineDef
        ();

    void de
        ();


    public:

    ~TextFile();

    // (API) :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    TextFile
        ();

    int phresh
        (
        char *filename,
        ulong lines,
        ulong mode
        );

    int load
        (
        char *filename,
        ulong mode
        );

    int save
        ();

    int save
        (
        char *filename
        );

    int currentLine
        (
        char *dst,
        ulong max
        );

    int overwriteLine
        (
        char *src
        );

    int deleteLine
        ();

    ulong currentLineNUM
        ();

    ulong lastLineNUM
        ();

    int moveCursorABS
        (
        ulong x
        );

    int moveCursorREL
        (
        int x
        );

    int print
        (
        ulong a,
        ulong b,
        int skipEmpty
        );

};
